<?php

/**
 * co_tipo_captura_prueba actions.
 *
 * @package    contratacion
 * @subpackage co_tipo_captura_prueba
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class co_tabla_ccActions extends sfActions
{
 /**
  * Executes list action
  *
  * @param sfRequest $request A request object
  */
  public function executeList(sfWebRequest $request)
  {
    //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {
            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }
            $sql = <<<EOD
 ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            CN_TABLE::executeSQL($sql);
            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from CO_TABLA_CC
EOD;
            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];
            //validar si hay registros
            if ($total_record_count > 0) {
                $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
select tab0.* from CO_TABLA_CC tab0  
where 1 = 1
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
                //ejecuta y obtiene el resultado del sql
                $records = CN_TABLE::executeSQL($sql);
                // Solo registra log la primera vez de consulta
                if ($rowStart == 0) {
                    //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
                    $id_ope_bd = 1;
                    //obtener id maestro tabla
                    $id_mae_bd = CN_TABLE::consultarIdTablaBD('CO_TABLA_CC');
                    //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
                    //  $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd);
                }
                $this->totalRows = $total_record_count;
                $this->startRow = $rowStart;
                $this->endRow = $rowStart + count($records);
                $this->status = 0;
                $this->list_data = $records;
                $this->logMessage("[INF_CO_TABLA_CC] Consulta exitosa.");
            }
            else {

                $mensaje = "[INF_CO_TABLA_CC] No hay registros de consulta.";
                $this->status = 0;
                $this->list_data = array();
                $this->logMessage($mensaje);
            }
        } catch (Exception $ex) {
            $error = "[INF_CO_TABLA_CC] ERROR: " . $ex->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
  }
  public function executeAdd(sfWebRequest $request)
  {
    $this->logMessage("[INF_CO_TABLA_CC] Entra por agregar objeto.");
    //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {
            $sql = <<<EOD
 ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            CN_TABLE::executeSQL($sql);
            /*
             * SQL QUE INSERTA EN LA TABLA DE OBJETO RELACION LOS DATOS 
             */
            $tabla=$request['tabla'];
            $nombre_cc=$request['nombre_cc'];
            $descripcion=$request['descripcion'];
            $campo_mostrar=$request['campo_mostrar'];
            $id_campo_buscar=$request['id_campo_buscar'];
            $sql = <<<EOD
INSERT INTO CO_TABLA_CC (ID_TABLA_CC, TABLA, NOMBRE_CC, DESCRIPCION, CAMPO_MOSTRAR, ID_CAMPO_BUSCAR) VALUES ('','$tabla','$nombre_cc','$descripcion','$campo_mostrar','$id_campo_buscar')
EOD;
            //ejecuta y obtiene el resultado del sql
             $records = CN_TABLE::executeSQL($sql);
             $this->status = 0;
             $this->list_data = $records;
             $this->logMessage("[INF_CO_TABLA_CC] Consulta exitosa, DATOS INGRESADOS:$descripcion");
        } catch (Exception $ex) {
            $error = "[INF_CO_TABLA_CC] ERROR: " . $ex->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
  }
  public function executeUpdate(sfWebRequest $request)
  {
    $this->logMessage("[INF_CO_TABLA_CC] Entra por editar objeto.");
    //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {
            $sql = <<<EOD
 ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            CN_TABLE::executeSQL($sql);
            /*
             * SQL QUE INSERTA EN LA TABLA DE OBJETO RELACION LOS DATOS 
             */
            $id=$request['id_tabla_cc'];
            $tabla=$request['tabla'];
            $nombre_cc=$request['nombre_cc'];
            $descripcion=$request['descripcion'];
            $campo_mostrar=$request['campo_mostrar'];
            $id_campo_buscar=$request['id_campo_buscar'];
            $sql = <<<EOD
UPDATE CO_TABLA_CC SET  TABLA='$tabla',NOMBRE_CC='$nombre_cc',DESCRIPCION='$descripcion',CAMPO_MOSTRAR='$campo_mostrar',ID_CAMPO_BUSCAR='$id_campo_buscar' WHERE ID_TABLA_CC=$id
EOD;
            //ejecuta y obtiene el resultado del sql
             $records = CN_TABLE::executeSQL($sql);
             $this->status = 0;
             $this->list_data = $records;
             $this->logMessage("[INF_CO_TABLA_CC] Consulta exitosa, DATOS ACTUALIZADOS:$descripcion");
        } catch (Exception $ex) {
            $error = "[INF_CO_TABLA_CC] ERROR: " . $ex->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
  }
  public function executeRemove(sfWebRequest $request)
  {
    $this->logMessage("[INF_CO_TABLA_CC] Entra por eliminar objeto.");
    //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {
            $sql = <<<EOD
 ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            CN_TABLE::executeSQL($sql);
            /*
             * SQL QUE INSERTA EN LA TABLA DE OBJETO RELACION LOS DATOS 
             */
            $id=$request['id_tabla_cc'];
            $sql = <<<EOD
DELETE FROM CO_TABLA_CC WHERE ID_TABLA_CC=$id
EOD;
            //ejecuta y obtiene el resultado del sql
             $records = CN_TABLE::executeSQL($sql);
             $this->status = 0;
             $this->list_data = $records;
             $this->logMessage("[INF_CO_TABLA_CC] Consulta exitosa, DATO ELIMINADO:$id");
        } catch (Exception $ex) {
            $error = "[INF_CO_TABLA_CC] ERROR: " . $ex->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
  }
}